/*
   ************************************************************
   Function to check and return a constant for the current view
   mode                                                        
   ************************************************************
*/
function getViewMode() {
	var isInHSView = isHSViewMode();
	
	if (isInHSView) {
		// Mini mode
		CURRENT_VIEWMODE = "mini";
	} else {
		// Full mode
		CURRENT_VIEWMODE = "full";
	}
	setTimeout(windowResized, 250);
	return CURRENT_VIEWMODE;
}

// Device resolutions. Can be used for device-specific customization.
var RESOLUTION_UNDEFINED = 0;
var RESOLUTION_QVGA_LANDSCAPE = 1;  // 320x240
var RESOLUTION_QVGA_PORTRAIT = 2;   // 240x320
var RESOLUTION_NHD_LANDSCAPE = 3;   // 640x360
var RESOLUTION_NHD_PORTRAIT = 4;    // 360x640
var RESOLUTION_HOME_SCREEN = 5;     // less than 75 % of the resolutions above
var RESOLUTION_NHDS_LANDSCAPE = 6;   // 502x360
var resolution = RESOLUTION_UNDEFINED;

// Detects the resolution of the device
function detectResolution() {
    var screenWidth = screen.width;
    var screenHeight = screen.height;
    var windowWidth = window.innerWidth;
    var windowHeight = window.innerHeight;
 
    if (windowHeight < (0.75 * screenHeight) ||
        windowWidth < (0.75 * screenWidth)) {
        // If the window width or height is less than 75 % of the screen width
        // or height, we assume the home screen view should be active
        resolution = RESOLUTION_HOME_SCREEN;
    } else if (screenWidth == 240 && screenHeight == 320) {
        resolution = RESOLUTION_QVGA_PORTRAIT;
    } else if (screenWidth == 320 && screenHeight == 240) {
        resolution = RESOLUTION_QVGA_LANDSCAPE;
    } else if (screenWidth == 360 && screenHeight == 640) {
        resolution = RESOLUTION_NHD_PORTRAIT;
    } else if (windowWidth == 502 && screenHeight == 360) {
        resolution = RESOLUTION_NHDS_LANDSCAPE;
    } else if (screenWidth == 640 && screenHeight == 360) {
        resolution = RESOLUTION_NHD_LANDSCAPE;
    } else {
        resolution = RESOLUTION_UNDEFINED;
    }
}

// Sets the active stylesheet for the HTML document according to the specified
// title.
function setActiveStyleSheet(title) {
    var stylesheets = document.getElementsByTagName("link");
    for (var i = 0; i < stylesheets.length; i++) {
        var stylesheet = stylesheets[i];
        // If the stylesheet doesn't contain the title attribute, assume it's
        // a persistent stylesheet and should not be disabled
        if (!stylesheet.getAttribute("title")) {
            continue;
        }
        // All other stylesheets than the one specified by "title" should be
        // disabled
        if (stylesheet.getAttribute("title") != title) {
            stylesheet.disabled = true;
        } else {
            stylesheet.disabled = false;
        }
    }
	if (WRTui.currentView.id == 'main_view') recommendCarousel.initWagons();

}

// Called when the window is resized
function windowResized() {
    var prevResolution = resolution;
 
    // Detect the new resolution
    detectResolution();
 
    if (resolution == RESOLUTION_NHD_PORTRAIT) {
        setActiveStyleSheet("NHD Portrait");
    } else if (resolution == RESOLUTION_NHDS_LANDSCAPE) {
        setActiveStyleSheet("NHDS Landscape");
    } else if (resolution == RESOLUTION_NHD_LANDSCAPE) {
        setActiveStyleSheet("NHD Landscape");
    } else if (resolution == RESOLUTION_QVGA_PORTRAIT) {
//        setActiveStyleSheet("QVGA Portrait");
    } else if (resolution == RESOLUTION_QVGA_LANDSCAPE) {
//        setActiveStyleSheet("QVGA Landscape");
    } else if (resolution == RESOLUTION_HOME_SCREEN) {
        // setActiveStyleSheet("Home Screen");
    } else if (resolution == RESOLUTION_UNDEFINED) {
        // TODO: Error handling
    }
	
	if (isSet(mainView.top5Table)) {
		recommendCarousel.resetWagons(recommendCarousel,1,0);
		genreCarousel.resetWagons(genreCarousel,1,0);
	}

}