/*
 **********************
 Populate the Main view
 **********************
 */
var CAROUSEL_CHANGE_PERIOD = 30 * 1000;
//================
//entry point
function drawMainView(callbackAfterMainViewVariablesAreInitialized){
	if (exposeUpdate(mainView)) {
		WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['LoadingMainViewData']);
		checkGenres(callbackAfterMainViewVariablesAreInitialized);
	} else {
		if (isSet(callbackAfterMainViewVariablesAreInitialized)) 
			eval(callbackAfterMainViewVariablesAreInitialized);		
	}
}

//================
//step 1
function checkGenres(callbackAfterMainViewVariablesAreInitialized){
	getGenresForCurrentMusicStore(callbackAfterMainViewVariablesAreInitialized);
}

function hasGenresForCurrentMusicStore(){
    return getAPICommostRecentGenresList() != null;
}

function getGenresForCurrentMusicStore(callbackAfterMainViewVariablesAreInitialized){
    initAPICom(settingsMusicStoreISO, apTable + "-" + settingsAp + "-" + apView + "-" + bqCounter + "-" + bqTimer);
    var APICom_ = new APICom(function(data){    
        checkGenresItems(callbackAfterMainViewVariablesAreInitialized);
    }, function(event){
//		alert('getGenresForCurrentMusicStore');
        mainScreenRefreshFailure();
    });
    APICom_.getGenres();
}

//================
//step 2
function checkGenresItems(callbackAfterMainViewVariablesAreInitialized){
        if (!hasItemsForSelectedGenre()) {
            //if merchandizer selected it will get banners and items at the same time
            getItemsForSelectedGenre(callbackAfterMainViewVariablesAreInitialized);
        }
        else {
            checkBanners(callbackAfterMainViewVariablesAreInitialized);
        }
}

function getItemsForSelectedGenre(callbackAfterMainViewVariablesAreInitialized){

    initAPICom(settingsMusicStoreISO, apTable + "-" + settingsAp + "-" + apView + "-" + bqCounter + "-" + bqTimer);
        var APICom_ = new APICom(function(data){
            checkBanners(callbackAfterMainViewVariablesAreInitialized);
        }, function(event){
//			alert('getItemsForSelectedGenre');
            mainScreenRefreshFailure();
        });
        		
        if (settingsGenreID != null && settingsGenreID < getAPICommostRecentGenresList().length) {
            APICom_.getGenreTop5List(settingsGenreName);
        }
        else {
            APICom_.getMerchandizerData(settingsMusicStoreISO);
        }
}

function hasItemsForSelectedGenre(){
    //this should hold either genres or editors
    return getAPICommostRecentTop5GenresList() != null;
}


//================
//step 3
function checkBanners(callbackAfterMainViewVariablesAreInitialized){
    if (!hasBannersForCurrentMusicStore()) {
        //if other genre then here we have to get that list anyways
        getBannersForCurrentMusicStore(callbackAfterMainViewVariablesAreInitialized);
    }
    else {
        mainScreenDataRefreshSuccess(callbackAfterMainViewVariablesAreInitialized);
    }
}

//================
//step 4
function getBannersForCurrentMusicStore(callbackAfterMainViewVariablesAreInitialized){
    var APICom_ = new APICom(function(data){    
        mainScreenDataRefreshSuccess(callbackAfterMainViewVariablesAreInitialized);
    }, function(event){
//		alert('getBannersForCurrentMusicStore');
        mainScreenRefreshFailure();
    });
    
    APICom_.getMerchandizerData(settingsMusicStoreISO);    
}

function hasBannersForCurrentMusicStore(){
    return getAPIComMostRecentBannersList() != null;
}

function mainScreenRefreshFailure(){
    WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['ErrorLoadingMainViewData'], 2000);
}

function mainScreenDataRefreshSuccess(callbackAfterMainViewVariablesAreInitialized){
    refreshMainView();
    if (isSet(callbackAfterMainViewVariablesAreInitialized)) {
        eval(callbackAfterMainViewVariablesAreInitialized);
    }
}

function refreshMainView(){
    drawMainView_('drawMiniView();');
}

function drawMainView_(callback){

    drawMainViewTop5DataRetrieved(callback);
    
}

var GET_TYPE_ARTIST = 0;
var GET_TYPE_ALBUM = 1;
var GET_TYPE_TRACK = 2;

function drawMainViewTop5DataRetrieved(callback){

        mainView.reset(LOCALISED_STRINGS[settingsMusicStoreISO]['ApplicationName']);
        mainTable = new UITable('mainTable', null, null, 'ulForm');
        
        mainTable.addFormInputText('searchInput', LOCALISED_STRINGS[settingsMusicStoreISO]['FindMusic']);
        mainTable.elements['searchInput'].addEventListener('focus', searchInputFocus, false);        
       
        mainTable.addFormButton(null, 'liFormButtonSearch', searchMusic);
        
        mainView.addControl(mainTable);
        
        var JSONGenres = getAPICommostRecentGenresList();
        
        var elements = new Array();
        for (i = 0; i < JSONGenres.length; i++) {
            elements[i] = JSONGenres[i].title;
        }
        
        elements[JSONGenres.length] = mostRecentEditorsHeading; //"Editors";
        
        mainView.numElementsAbove = 1;
        mainView.top5Table = new UITable('top5Table', null/*"Recommended"*//*LOCALISED_STRINGS[settingsMusicStoreISO]['Top5tracks']*/, null);
        
		exposeContent = getRecomendationsArray();
			
		recommendCarousel = mainView.top5Table.addRecommendCarousel('recommenders','RecommendedCarousel','RecommendedCarouselItemDIV',exposeContent,launchNMSapp,generateRecommendElement,'','',function(){return null;});
			
		mainView.numElementsAbove++;

		genreCarousel = mainView.top5Table.addWRTuiCarousel('genreCarousel','Carousel','CarouselActionArea',elements,genreActionCallback,generateGenreElement,'CarouselLeft','CarouselRight',genreItemSelectedCallback);
	
		fillTop5Table(mainView.top5Table);

        mainView.addControl(mainView.top5Table);
		
		if (settingsGenreID == null) {
			settingsGenreID = genreCarousel.elements.length-1;
			settingsFavGenreID = settingsGenreID;
			genreCarousel.contentCnt = settingsFavGenreID;
			genreCarousel.initWagons(genreCarousel.elements[settingsFavGenreID]);
		} else {
			genreCarousel.contentCnt = settingsGenreID;
			genreCarousel.initWagons(genreCarousel.elements[settingsGenreID]);
		}
		settingsGenreName_ = '';
		
		if (settingsGenreID < JSONGenres.length) {
			settingsGenreName_ = JSONGenres[settingsGenreID].genreId;
		}
		saveSettingsGenreID(settingsGenreID, settingsGenreName_)
		
		recommendCarousel.initWagons(exposeGetRandomItem());
		recommendCarousel.animateCarousel(true);
		setTimeout('refreshCarousel(recommendCarousel,true)',15000);

        if (isSet(callback)) {
            eval(callback);
        }
        
	WRTui.hideAlert();
}

function generateGenreElement(genreElement) {
    var starHTML = '<div class="StarGray"></div>';
    if (genreCarousel.contentCnt == settingsFavGenreID) {
        starHTML = '<div class="Star"></div>';
    }

	var htmlItem = document.createElement('div');
	htmlItem.innerHTML = starHTML + '<div class="CarouselItemText">' + genreElement + '</div>';
	return htmlItem;
}

function genreActionCallback(){
	index = genreCarousel.contentCnt;
	
	$('.StarGray').removeClass('StarGray').addClass('Star');
	
	//ITEM #index MARKED WITH YELLOW STAR
   	var JSONGenres_ = getAPICommostRecentGenresList();

	settingsGenreName_ = settingsGenreName;
	
	if (settingsGenreID != null && settingsGenreID < JSONGenres_.length) {
		settingsGenreName_ = JSONGenres_[index].genreId;
	}
	settingsFavGenreID = index;
	saveSettingsGenreID(index, settingsGenreName_);
}

function genreItemSelectedCallback(){
	index = genreCarousel.contentCnt;

	WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['LoadingGenreData']);
//	clearTimeout(recommendCarousel.refreshTimer);

	//SELECTION CHANGED TO index
	var JSONGenres_ = getAPICommostRecentGenresList();
                
	if (index < JSONGenres_.length) {
		settingsGenreName = JSONGenres_[index].genreId;
	}
	    	
	settingsGenreID = index;
	var APICom_ = new APICom(function(data){
		//GOT TOP 15 DATA FROM THE SERVER
		var children = mainView.top5Table.rootElement.childNodes;
						
		while (children.length > mainView.numElementsAbove) {
			mainView.top5Table.rootElement.removeChild(children[mainView.numElementsAbove]);
		}

		fillTop5Table(mainView.top5Table);
		WRTui.hideAlert();
		//WHEN EVERYTHING IS READY REFRESH ALSO THE CAROUSEL
		refreshCarousel(recommendCarousel, true);
						
	}, function(event){
		//ERROR GETTING TOP 15 DATA fROM THE SERVER
		WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['ErrorLoadingGenreData'], 2000);
	});
                
	if (settingsGenreID != null && settingsGenreID < getAPICommostRecentGenresList().length) {
		APICom_.getGenreTop5List(settingsGenreName);
		hbTracking('contentLoaded',settingsGenreName);
	}
	else {
		APICom_.getMerchandizerData(settingsMusicStoreISO);
		hbTracking('contentLoaded', 'Editors');
	}

}

function refreshCarousel(carouselReference, scheduleRefresh){
	getGenreRecTracks(carouselReference, scheduleRefresh);
}

function generateRecommendElement(recElement) {
	var retElements = null;
	
	if (recElement.type == 'banner') {
		retElement = bannerItem(recElement);
	} else if (recElement.type == 'musictrack') {
		retElement = productItem(recElement);
	}		

	return retElement;
}

function getGenreRecTracks(carouselReference, scheduleRefresh) {
	var getType;
	var ID;
	if (settingsGenreID == getAPICommostRecentGenresList().length) {//editors list
		var editorsList = getAPIComMostRecentEditorsList();//getartistidhere
		getType = GET_TYPE_ARTIST;
		ID = editorsList[random(editorsList.length)].artistId;
	}
	else {//top items for genre
		//usual top15
		if (getAPICommostRecentTop5GenresList() != null) {
			var top15GenresList = getAPICommostRecentTop5GenresList().items;
			//get item array
			getType = GET_TYPE_ARTIST;
			if (top15GenresList.length > 0) {
				rndID = random(top15GenresList.length);
				ID = top15GenresList[rndID].artistId;
			} else {
				WRTui.showAlert("0 " + LOCALISED_STRINGS[settingsMusicStoreISO]['Tracks'], 2000);
			}
		}
	}
	var APICom_ = new APICom(function(data){
		exposeContent = getRecomendationsArray();
		exposeContent = exposeContent.concat(data.items);
		carouselReference.elements = exposeContent;
	}, function(event){
	});
	
	APICom_.getRecommendedTracksForArtist(ID);	
}
	
var currentTop5ListArray;
function fillTop5Table(top5Table){
    currentTop5ListArray = new Array();

        var top5ListParent;
        var top5List;
		
        if (settingsGenreID == null || settingsGenreID == getAPICommostRecentGenresList().length) {
            top5ListParent = getAPIComMostRecentEditorsList();
            //direct item array
            top5List = top5ListParent;

        } else {
			if (hasItemsForSelectedGenre() != null) {
				top5ListParent = getAPICommostRecentTop5GenresList();
				//get item array
				top5List = top5ListParent.items;
			}
        }
        
        for (var i = 0; i < top5List.length; i++) {

            var artistVar = top5List[i].artistName;//"artist";//$(node).attr("artist");
			if (artistVar instanceof Array) artistVar = artistVar.join(", "); 
			var tmpChk = artistVar.replace(/,/g,".");
            if (tmpChk.length > 24) {
                artistVar = artistVar.substring(0, 23) + "...";
            }

            var titleVar = top5List[i].name;//$(node).attr("title");
			var tmpChk = titleVar.replace(/,/g,".");
            if (tmpChk.length > 24) {
                titleVar = titleVar.substring(0, 23) + "...";
            }
            var mp3Clip;
            mp3Clip = top5List[i].mp3Clip;

            var buttonControl;

            if (mp3Clip != undefined) {
                buttonControl = top5Table.addRow('<div class="UITableRowPackshot"><div style="background:url(\'' + top5List[i].albumArt100 + '\');"><div class="playClipDIV"><img src="WRTui/Resources/empty.png" width="100" height="100"></div></div></div>' +
                '<span class="UITableRowArtist">' +
                artistVar +
                '</span><span class="UITableRowTrack">' +
                titleVar +
                '</span>', launchNMSapp);
            }
            else {
                buttonControl = top5Table.addRow('<div class="UITableRowPackshot"><div style="background:url(\'' + top5List[i].albumArt100 + '\');"><img src="WRTui/Resources/empty.png" width="100" height="100"></div></div>' +
                '<span class="UITableRowArtist">' +
                artistVar +
                '</span><span class="UITableRowTrack">' +
                titleVar +
                '</span>', launchNMSapp);
                
            }
            
            if (mp3Clip != undefined) {
                buttonControl.audioLink = mp3Clip;
                buttonControl.genreName = top5List[i].genreName;
            }
            buttonControl.hrefLink = top5List[i].storeUri;
            currentTop5ListArray.push(buttonControl);
        }
}

function getRecomendationsArray(){
    var list = getAPIComMostRecentBannersList();
	for (var i = 0; i < list.length; i++) {
        list[i].type = 'banner';
    }

    return list;
}

function bannerItem(objectItem) {
	var htmlItem = document.createElement('div');
	htmlItem.innerHTML = '<img src="' + objectItem.image.uri + '" class="" width="360" height="100">';
	htmlItem.hrefLink = objectItem.link;

	return htmlItem;
}

function productItem(objectItem) {
    var htmlItem = document.createElement('div');
	var artistVar = objectItem.artistName;
	if (artistVar instanceof Array) artistVar = artistVar.join(", "); 
	var tmpChk = artistVar.replace(/,/g,".");
	if (tmpChk.length > 24) {
		artistVar = artistVar.substring(0, 23) + "...";
	}

	var titleVar = objectItem.name;
	var tmpChk = titleVar.replace(/,/g,".");
	if (titleVar.length > 24) {
		titleVar = titleVar.substring(0, 23) + "...";
	}

	htmlItem.innerHTML = '<div class="UITableRowPackshotRecommenders"><div style="background:url(\'' + objectItem.albumArt100 + '\');"><div class="playClipDIV"><img src="WRTui/Resources/empty.png" width="100" height="100"></div></div></div>' +
		'<span class="UITableRowArtist" style="padding: 30px 0px 0px 0px;">' +
		artistVar +
		'</span><span class="UITableRowTrack">' +
		titleVar +
		'</span>';

	htmlItem.hrefLink = objectItem.storeUri;
	htmlItem.audioLink = objectItem.mp3Clip;

	return htmlItem;
}

//PLAYER CONTROLS CALLBACKS
function playPressed(item){
	WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['StreamLoading']);
	hbTracking('30secClip',item.genreName);
	setTimeout('flashPlayer(1, "'+item.audioLink+'");',250);
}

function replaceAllStopButtonsWithPlayButtons(){
        if (currentTop5ListArray != undefined) {
            for (var i = 0; i < currentTop5ListArray.length; i++) {
                if (currentTop5ListArray[i].audioLink != undefined) {
                    currentTop5ListArray[i].childNodes[0].childNodes[0].childNodes[0].className = "playClipDIV";
                }
            }
        }
}
