/*
 **********************************************************
 Function for drawing the Search results view from Main -\>
 Search
 **********************************************************
 */
function searchPageSelected(eventObject){
    optionObj = eventObject.currentTarget.childNodes[0];//getChild();//className;
    var choosenOption = optionObj.value;
    
    var data = getAPIComMostRecentSearchResults();
    var link = null;
    if (data.paging.nextPageUri != null) {
        link = data.paging.nextPageUri;
    } else if (data.paging.prevPageUri != null) {
            link = data.paging.prevPageUri;
	}
    link = link.substr(0, link.indexOf('&startindex=') + 12) + choosenOption;
    
    var APICom_ = new APICom(function(data_){
        WRTui.hideAlert();
        if (data_.paging.totalResults <= 0) {
			WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['NoSearchResults'], 2000);
        }
        else {
        	setAPIComMostRecentSearchResults(data_);
        	drawSearchView(data_, 'showSearchView()');        			
        }
    }, function(event){
        WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['ConnectionError'], 2000);
    });
    
    
    //lunch action for lastSearchResults.paging.nextPageUri with modified page index
    APICom_.getLinkData(link);
    WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['Searching']);  
}

function drawSearchView(data, callback){
        searchView.reset();
        
        searchTable = new UITable('searchTable', null, null);
        
		searchView.gettingMoreContent = false;

        var pageCount = Math.ceil(data.paging.totalResults / data.paging.itemsPerPage);//Number(pageCount.replace(/^\D+/,""));
		searchView.pageCount = pageCount;
        
		var currentPage = data.paging.startIndex;
		        
        var items = data.items;
        
        var itemCount = 0;
        for (var i = 0; i < items.length; i++) {        
            var item = items[i];
			itemCount += createSearchElement(searchTable,item);
        }
 
        if (data.paging.totalResults > 20) {
			var rowtext = loadingMoreElement();
			searchTable.addHTMLElement(rowtext);
			searchView.liveScrollingTick = setInterval(scrollHandler,500);
		}
		
        searchView.addControl(searchTable);
        if (isSet(callback)) 
            eval(callback);
}

function loadingMoreElement() {
    var imageFrames = new Array('WRTui/Resources/loader_f01.png', 'WRTui/Resources/loader_f02.png', 'WRTui/Resources/loader_f03.png', 'WRTui/Resources/loader_f04.png', 'WRTui/Resources/loader_f05.png', 'WRTui/Resources/loader_f06.png', 'WRTui/Resources/loader_f07.png', 'WRTui/Resources/loader_f08.png');
    searchView.loadingAnimator = new MultipleImagesAnimator('', imageFrames, 100);

	returnHTML = '<div id="searchLoadingText" class="UILiveScrolling"><table width="100%" height="100%" border="0" cellpadding="0" cellspacing="0"><tr><td valign="middle" align="center">' + LOCALISED_STRINGS[settingsMusicStoreISO]['Searching'] + '<img id="searchLoadingImage" src="WRTui/Resources/loader_f01.png" align="absmiddle" style="margin-left:10px;"></td></tr></table></div>';
	return returnHTML;
}

function searchGetMoreContent() {
	if (searchView.pageCount > 0 && searchView.currentPage < searchView.pageCount-1) {
		clearInterval(searchView.liveScrollingTick);
		searchView.currentPage++;
		searchView.loadingAnimator.imageElement = document.getElementById('searchLoadingImage');
		searchView.loadingAnimator.start();

		var data = getAPIComMostRecentSearchResults();
		var link = null;
		if (data.paging.nextPageUri != null) {
			link = data.paging.nextPageUri;
		}
		else {
			if (data.paging.prevPageUri != null) {
				link = data.paging.prevPageUri;
			}
		}
		link = link.substr(0, link.indexOf('&startindex=') + 12) + searchView.currentPage;
		
		var APICom_ = new APICom(function(data_){
			WRTui.hideAlert();
			if (data_.paging.totalResults <= 0) {
				WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['NoSearchResults'], 2000);
			}
			else {
				setAPIComMostRecentSearchResults(data_);
				searchAddMoreContent(data_);
				//here pass parameters to a method which should create the search results screen
				//drawSearchView(exactMatch,response1,response2,searchResults,pageCount,selectSearch,0,'showSearchView()');
			}
		}, function(event){
			WRTui.showAlert(LOCALISED_STRINGS[settingsMusicStoreISO]['ConnectionError'], 2000);
		});
		
		//lunch action for lastSearchResults.paging.nextPageUri with modified page index
		APICom_.getLinkData(link);
	}
}

function searchAddMoreContent(data) {
	var items = data.items;
	
	searchView.loadingAnimator.imageElement = document.getElementById('searchLoadingImage');
	searchView.loadingAnimator.stop();

	tableElementsCount = searchView.elements[0].rowElements.length;
	searchView.elements[0].removeRow(tableElementsCount-1);
	
	for (var i = 0; i < items.length; i++) {
		var item = items[i];
		createSearchElement(searchView.elements[0],item);
	}
		
	if (searchView.currentPage < searchView.pageCount-1) {
		var rowtext = loadingMoreElement();
		searchView.elements[0].addHTMLElement(rowtext);
		searchView.liveScrollingTick = setInterval(scrollHandler,500);
	}
	
	searchView.gettingMoreContent = false;

}

function createSearchElement(uiElementRef,item) {
    var returnInt = 0;

    var typeVar = item.type;
    if (typeVar == undefined) {
        typeVar = "unknown type";
    }
	if (typeVar == "musicartist") {
    	var artistVar = item.name;
    } else {
    	var artistVar = item.artistName;
    }
	if (artistVar instanceof Array) artistVar = artistVar.join(", "); 
    if (artistVar == undefined) {
        artistVar = "";
    }
    if (artistVar.length > 24) {
        artistVar = artistVar.substring(0, 23) + "...";
    }
    var titleVar = item.name;//$(node).attr("title");
    if (titleVar == undefined) {
        titleVar = "";
    }
    if (titleVar.length > 24) {
        titleVar = titleVar.substring(0, 23) + "...";
    }
    var labelVar = item.label;//$(node).attr("title");
    if (labelVar == undefined) {
        labelVar = "";
    }
    if (labelVar.length > 24) {
        labelVar = labelVar.substring(0, 23) + "...";
    }
    
    var categoryVar = item.category;
    if (categoryVar == undefined) {
        categoryVar = "xxxcat";
    }
        
    var trackCountVar = item.trackCount;
    if (trackCountVar == undefined) {
        trackCountVar = "unknown count";
    }
    
    var trackLengthVar = item.duration;
    if (trackLengthVar == undefined) {
        trackLengthVar = "unknown duration";
    }
    else {
        var minutes = (trackLengthVar / 60) | 0;
        var seconds = (trackLengthVar % 60);
        trackLengthVar = (minutes > 9 ? minutes : '0' + minutes) + ":" + (seconds > 9 ? seconds : '0' + seconds);
        
    }
    
    var mp3Clip;
    try {
        mp3Clip = item.mp3Clip;
    } 
    catch (exception) {
    }
    
    var rowtext = '';
    if (typeVar == "musicartist") {
        rowtext += '<div class="UITableRowArtistBG"><img src="WRTui/Resources/empty.png" width="100" height="100"></div>';    	
    } else {
	    if (mp3Clip != undefined) {
	        rowtext += '<div class="UITableRowPackshot"><div style="background:url(\'' + item.albumArt100 + '\');"><div class="playClipDIV"><img src="WRTui/Resources/empty.png" width="100" height="100"></div></div></div>';
	    } else {
	        rowtext += '<div class="UITableRowPackshot"><div style="background:url(\'' + item.albumArt100 + '\');"><img src="WRTui/Resources/empty.png" width="100" height="100"></div></div>';
	    }
    }
    if (typeVar == "musicartist") {
        rowtext += '<span class = "UITableRowArtist" style="padding: 22px 0px 0px 0px;">&nbsp;</span>';
        rowtext += '<span class = "UITableRowCategory"><b>' + artistVar + '</b></span>';
        rowtext += '<span class = "UITableRowTrackLength">&nbsp;</span>';
        returnInt = 1;
    } else if (typeVar == "musiccollection") {
        rowtext += '<span class = "UITableRowArtist" style="padding: 22px 0px 0px 0px;">' + artistVar + '</span>';
        rowtext += '<span class = "UITableRowCategory">' + titleVar + '</span><br>';
		if (trackCountVar == 1) { trackStr = LOCALISED_STRINGS[settingsMusicStoreISO]['Track']; }
		else { trackStr = LOCALISED_STRINGS[settingsMusicStoreISO]['Tracks']; }
        rowtext += '<span class = "UITableRowTrackCount">' + trackCountVar + ' ' + trackStr + '</span>';
        returnInt = 1;
    } else if (typeVar == "musictrack") {
        rowtext += '<span class = "UITableRowArtist" style="padding: 22px 0px 0px 0px;">' + artistVar + '</span>';
        rowtext += '<span class = "UITableRowCategory">' + titleVar + '</span><br>';
        rowtext += '<span class = "UITableRowTrackLength">' + trackLengthVar + '</span>';
        returnInt = 1;
    } else {
		// dont add row item for anything that isn't an artist/collection/track
        return returnInt;
    }
	
    var buttonControl = uiElementRef.addRow(rowtext, launchNMSapp);
    if (mp3Clip != undefined) {
        buttonControl.audioLink = mp3Clip;
        buttonControl.genreName = item.genreName;
    }
    buttonControl.hrefLink = item.storeUri;
    return returnInt;
}
