/*
   **************************
   Populate the Settings view
   **************************
*/

function drawSettingsView(callback) {

	settingsView.reset(LOCALISED_STRINGS[settingsMusicStoreISO]['Settings']);

	settingsTable = new UITable('settingsTable',null,null,'ulFormSettings');

	settingsTable.addPanel(LOCALISED_STRINGS[settingsMusicStoreISO]['IntroText'] + '<br><br>' + LOCALISED_STRINGS[settingsMusicStoreISO]['SettingsInfo']);

	settingsTable.addDivider();

	// Create the storeSelect
	settingsTable.newFormSelect('storeSelect');

	settingsTable.addFormOption('storeSelect',-1, LOCALISED_STRINGS['gb']['NoNMSSelected']);
	for (i=1;i<MUSIC_STORES.length;i++) {
		var arrMusicStore = MUSIC_STORES[i].split(':');
		settingsTable.addFormOption('storeSelect',arrMusicStore[1],arrMusicStore[0]);
	}
	
	settingsTable.addFormSelect('storeSelect',LOCALISED_STRINGS[settingsMusicStoreISO]['SelectMusicStore'],selectMusicStoreChanged);

	settingsTable.elements['storeSelect'].selectedIndex = settingsMusicStore;

	if (!window.widget) 
		settingsTable.addRow('Save', savePreferences);

	settingsTable.addPanel(LOCALISED_STRINGS[settingsMusicStoreISO]['LocalisationNote'] + "\n\n");
	
	settingsTable.addDivider();

	settingsView.addControl(settingsTable);
	
	if (isSet(callback)) {
		eval(callback);
	}
}

