/**
 * Draw mini view - entry point
 * @param {Function} callback function to call after mini view is populated
 */
function drawMiniView(callback){
	if (exposeUpdate(miniView)) {
		checkBannersMiniView(callback);
	} else {
		if (isSet(callback)) 
			eval(callback);
	}
}

/**
 * Get banners if they are not present in APIComm cache
 * @param {Function} callbackAfterDataIsRetrieved function to call after mini view is populated
 */
function checkBannersMiniView(callbackAfterDataIsRetrieved){
    if (exposeContent.length == 0) {
        //if other genre then here we have to get that list anyways
        getBannersForCurrentMusicStoreMini(callbackAfterDataIsRetrieved);
	}
    else {
        drawMiniViewLocal(callbackAfterDataIsRetrieved);
    }

}

/**
 * Invoke banner retrieval
 * @param {Function} callbackAfterDataIsRetrieved function to call after mini view is populated
 */
function getBannersForCurrentMusicStoreMini(callbackAfterDataIsRetrieved){
    var APICom_ = new APICom(function(data){
        drawMiniViewLocal(callbackAfterDataIsRetrieved);
    }, function(event){
        miniViewDrawFailure();
    });
    
    APICom_.getMerchandizerData(settingsMusicStoreISO);
}

/**
 * Show error
 * NOTE: proper error message needs to be put here
 */
function miniViewDrawFailure(){
    WRTui.showAlert("Error loading Mini View !!", 2000);
}

/**
 * Populate mini view
 * @param {Function} callback function to call after mini view is populated
 */
function drawMiniViewLocal(callback){
    miniView.reset();
	
    miniView.parentElement.innerHTML = '<div id="div1" class="productDiv"></div><div id="div2" class="productDiv"></div>';
	$('#div1').html(getRecommendElement());
	miniView.currentIndex = exposeCurrentIndex;
    
    if (isSet(callback)) 
        eval(callback);
}

function getRecommendElement() {
	var htmlItem = exposeGetRandomItem();
	if (htmlItem.type == 'banner') {
		htmlItem = miniBannerItem(htmlItem);
	} else if (htmlItem.type == 'musictrack') {
		htmlItem = miniProductItem(htmlItem);
	}	
	return htmlItem;
}

function miniBannerItem(objectItem) {
	var htmlItem = document.createElement('div');
	htmlItem.innerHTML = '<img src="' + objectItem.image.uri + '" class="" width="312">';

	return htmlItem;
}

function miniProductItem(objectItem) {
    var htmlItem = document.createElement('div');
	var artistVar = objectItem.artistName;
	if (artistVar instanceof Array) artistVar = artistVar.join(", "); 
	if (artistVar.length > 24) {
		artistVar = artistVar.substring(0, 23) + "...";
	}

	var titleVar = objectItem.name;
	if (titleVar.length > 24) {
		titleVar = titleVar.substring(0, 23) + "...";
	}

	htmlItem.innerHTML = '<div style="width:100%;height:100%;background: url(graphics/packshotbg-mini.png) no-repeat; background-position: 10px 7px;"><img src="' + objectItem.albumArt100 + '" width="68" height="68" style="float:left;margin:6px 0px 0px 10px;border:1px solid;border-color:#ccc;"><span class="NavigationButtonTextNormal" style="font-size:18px;font-weight:bold;float:left;padding:20px 0px 0px 10px;">' + artistVar + '<br><font class="trackTitle">' + titleVar + '</font></span></div>';
	
	return htmlItem;
}


