/*
   ************************************************************
   Function for checking view mode.
   
   This function also contain code to check if the widget is
   being added to the Mini view the first time after install or
   not, this is used for generating usage statistics.          
   ************************************************************
*/
function checkViewMode() {
	WRTui.hideView();

	if (getViewMode()=='mini') {
		viewMode = 'mini';

		miniAdded = true;
		
		$("#splashScreen").hide();
		// Check if the trackHomeScreen has been set to 1 if not set it to indicate that the widget has been added to the home screen
		if (trackHomeScreen < 1) {
			// Trigger hitbox home screen counter
			hbTracking('homeScreen');
			trackHomeScreen = 2;
			widget.setPreferenceForKey(trackHomeScreen.toString(), "trackHomeScreen");
		}
		if (firstRun) {
			// If first run, show settings view
			showSettingsNote();
			initFull();
		} else {
			drawMiniView('showMiniView();');
		}

	} else {
		contentAnim = false;
		
		if (viewMode != 'full') {
			viewMode = 'full';
			
			if (firstRun) {
				drawSettingsView('showSettingsView();');
			} else {
				drawMainView('showMainView();');
			}			
			if (contentTimer != null) {
				clearTimeout(contentTimer);
				contentTimer = null;
			}
		} else {
			WRTui.showView();		
		}
	}
}
