function WRTuiCarousel(baseName,carouselStyleName,carouselItemStyleName,elements,callback,generateElement,prevBtnStyle,nextBtnStyle,animEndCallback) {
//function WRTuiCarousel(baseName,carouselStyleName,carouselItemStyleName,elements,callback,generateElement) {	
	this.baseName = baseName;
	this.carouselStyleName = carouselStyleName;
	this.carouselItemStyleName = carouselItemStyleName;
	this.visibleDiv = this.baseName+'Div1';
	this.bufferDiv = this.baseName+'Div2';
	this.animating = false;
	this.contentCnt = 0;
	this.elements = elements;
	this.callback = callback;
	this.animState = false;
	this.generateElement = generateElement;
	this.animQ = new Array();
	this.pollCnt = 0;
	this.animEndCallback = animEndCallback;

	this.rootElement = document.createElement('div');
	
	var thisRef2 = this;
	if (this.prevBtnStyle!='') {
		this.prevBtnStyle = prevBtnStyle;
		this.prevAction = function() { thisRef2.getContent(-1); };
	}
	if (this.nextBtnStyle!='') {
		this.nextBtnStyle = nextBtnStyle;
		this.nextAction = function() { thisRef2.getContent(1); };
	}
	
	this.init();
}

WRTuiCarousel.prototype.init = function() {
	prevHTML = '';
	nextHTML = '';

	if (this.prevBtnStyle!='') {
		prevHTML = '<div id="'+this.baseName+'Prev" class="'+this.prevBtnStyle+'"></div>';
	}
	if (this.nextBtnStyle!='') {
		nextHTML = '<div id="'+this.baseName+'Next" class="'+this.nextBtnStyle+'"></div>';	
	}

	this.rootElement.innerHTML = '<div class="'+this.carouselStyleName+'">'+prevHTML+'<div id="'+this.baseName+'Div1" class="'+this.carouselItemStyleName+'"></div><div id="'+this.baseName+'Div2" class="'+this.carouselItemStyleName+'"></div>'+nextHTML+'</div>';
}

WRTuiCarousel.prototype.initWagons = function(object1) {
	if (this.prevBtnStyle!='') {
		prevElement = document.getElementById(this.baseName+'Prev');
		prevElement.addEventListener('click', this.prevAction, false);
	}
	if (this.nextBtnStyle!='') {
		nextElement = document.getElementById(this.baseName+'Next');
		nextElement.addEventListener('click', this.nextAction, false);
	}
	
	if (isSet(object1)) {
		object1 = this.generateElement(object1);
		tmpElement = document.getElementById(this.baseName+'Div1');
		tmpElement.appendChild(object1);
		object1.addEventListener('click', this.callback, false);
	}
	if (this.bufferDiv == this.baseName+'Div2') {
		$('#'+this.baseName+'Div1').css('left', 0);
		$('#'+this.baseName+'Div2').css('left', window.innerWidth);
	} else {
		$('#'+this.baseName+'Div2').css('left', 0);
		$('#'+this.baseName+'Div1').css('left', window.innerWidth);
	}
	$('.'+this.carouselItemStyleName).animate({'left': '-='+0}, 100, 'swing', function() {} );

}

WRTuiCarousel.prototype.animateCarousel = function(animState) {
	this.animState = animState
	if (animState) {
		var thisRef = this;
		this.animTick = setTimeout( function() {
			thisRef.getContent(0);
		}, 30000);
	} else {
		clearInterval(this.animTick);
	}
}

WRTuiCarousel.prototype.animateWagons = function(animDir) {
	if (!this.animating) {
		this.animating = true;
		var thisRef = this;
		animWidth = $('#'+this.baseName+'Div1').css('width');
		this.resetWagons(thisRef,animDir,1);
		if (animDir==1) {
			$('.'+this.carouselItemStyleName).animate({'left': '-='+animWidth}, 2000, 'swing', function() { thisRef.pollAnimQ(thisRef); } );
		} else {
			$('.'+this.carouselItemStyleName).animate({'left': '+='+animWidth}, 2000, 'swing', function() { thisRef.pollAnimQ(thisRef); } );
		}
	}
}

WRTuiCarousel.prototype.pollAnimQ = function(thisRef) {
	thisRef.animating = false;

	if (thisRef.pollCnt==1) {
		thisRef.pollCnt = 0;
		if (thisRef.animQ.length != 0) {
			var nextAction = thisRef.animQ.shift();
			thisRef.getContent(nextAction);
		} else {
			this.animEndCallback.call();
		}
	} else {
		thisRef.pollCnt++;
	}

}

WRTuiCarousel.prototype.resetWagons = function(thisRef,animDir,animState) {
	leftVar = (parseInt(window.innerWidth)*animDir);
	if (thisRef.bufferDiv == thisRef.baseName+'Div2') {
		$('#'+thisRef.bufferDiv).css('left', leftVar);
		if (animState) {
			thisRef.visibleDiv = thisRef.bufferDiv;
			thisRef.bufferDiv = thisRef.baseName+'Div1';
		}
	} else if (thisRef.bufferDiv == thisRef.baseName+'Div1') {
		$('#'+thisRef.bufferDiv).css('left', leftVar);
		if (animState) {
			thisRef.visibleDiv = thisRef.bufferDiv;
			thisRef.bufferDiv = thisRef.baseName+'Div2';
		}
	}
}

WRTuiCarousel.prototype.setBuffer = function(contentObj) {
	contentObj = this.generateElement(contentObj);
	$('#'+this.bufferDiv).html('');
	tmpElement = document.getElementById(this.bufferDiv);
	tmpElement.appendChild(contentObj);
	contentObj.addEventListener('click', this.callback, false);
}

WRTuiCarousel.prototype.setVisible = function(contentObj) {
	contentObj = this.generateElement(contentObj);
	$('#'+this.visibleDiv).html('');
	tmpElement = document.getElementById(this.visibleDiv);
	tmpElement.appendChild(contentObj);
	contentObj.addEventListener('click', this.callback, false);	
}

WRTuiCarousel.prototype.getContent = function(contentMode) {
	this.pollCnt = 0;
	// contentMode
	// 0 = random item in the content array
	// 1 = next in the content array
	// -1 = previous in the content array
	if (!this.animating) {
		if (contentMode==0) {
			this.setBuffer(this.elements[Math.floor(Math.random()*(this.elements.length-1))]);
			this.animateWagons(1);
			this.animateCarousel(true);
		} else if (contentMode==1) {
			this.contentCnt++;
			if (this.contentCnt>this.elements.length-1) this.contentCnt = 0;
			this.setBuffer(this.elements[this.contentCnt]);
			this.animateWagons(1);		
		} else if (contentMode==-1) {
			this.contentCnt--;
			if (this.contentCnt<0) this.contentCnt = this.elements.length-1;
			this.setBuffer(this.elements[this.contentCnt]);
			this.animateWagons(-1);		
		}	
	} else {
		this.animQ.push(contentMode);
	}
}