/*
   ****************************************************
   Music Store widget using WRTui library
   
   Nokia Copyright 2010
   
   ****************************************************
*/

// Widget version // [Major].[Minor] [Stage] [OneBytePreReleaseVersion]
var widgetVersion = "3.0"; // Used to check real version against the feeds
var widgetVersionString = "3.0"; // Used to display for version identifictation

if (window.widget) {
	if (isSet(widget.preferenceForKey("WidgetVersion"))) {
		widgetVersion = widgetVersionString = widget.preferenceForKey("WidgetVersion");
	}
}

// Music explorer app server
var appServer = 'http://www.musicexplorer.info/';

var imageFrames = new Array(
	'WRTui/Resources/loader_f01.png',
	'WRTui/Resources/loader_f02.png',
	'WRTui/Resources/loader_f03.png',
	'WRTui/Resources/loader_f04.png',
	'WRTui/Resources/loader_f05.png',
	'WRTui/Resources/loader_f06.png',
	'WRTui/Resources/loader_f07.png',
	'WRTui/Resources/loader_f08.png'
);
var loadingAnimator = new MultipleImagesAnimator('',imageFrames,100);

function startup() {
	//alert('startup');
	if (window.widget) {
		window.widget.setNavigationEnabled(false);
	}

	if (getViewMode() == "full") {
		// Show the splash screen
		showFullSplash();
		loadingAnimator.imageElement = document.getElementById('loadingImage');
		setTimeout("loadingAnimator.start();", 50);
	} else {
		// Show the splash screen
		showMiniSplash();
	}

	setTimeout("fL.poll();", 100);
}

// Variables used when handling different view modes
var HS_VIEW_THRESHOLD = 150;
var CURRENT_VIEWMODE = null;

/*
   *******************************************
   Function to handle the different view modes
   *******************************************
*/
function isHSViewMode() {
	   var screenHeight = window.innerHeight;
	   return ( screenHeight < HS_VIEW_THRESHOLD );
}

/*
   ************************************************************
   Function to check and return a constant for the current view
   mode                                                        
   ************************************************************
*/
function getViewMode() {
	var isInHSView = isHSViewMode();
	
	if (isInHSView) {
		// Mini mode
		CURRENT_VIEWMODE = "mini";
	} else {
		// Full mode
		CURRENT_VIEWMODE = "full";
	}
	return CURRENT_VIEWMODE;
}

/*
   ********************************************
   Function to display full screen splash image
   ********************************************
*/
function showFullSplash() {
	// Create the fullscreen splash content
	var splashTextString = '<i>'+widgetVersionString+'</i>';
	var splashHtml = '<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0"><tr><td align="center"><div style="width:250px"><div class="splashImg"><img alt="" src="splashbg.png" class="splash_logo_full" onload="var splashDiv = document.getElementById(\'splashScreen\');splashDiv.className = \'splash_table\';"/></div><div class="splashTxt" id="splashTxt">'+splashTextString+'<br><br><img id="loadingImage" src="WRTui/Resources/loader_f01.png"></div></div></td></tr></table>';
	var splashDiv = document.getElementById('splashScreen');
	splashDiv.innerHTML = splashHtml;
}

/*
   ********************************
   Show the Mini view splash screen
   ********************************
*/
function showMiniSplash() {
	// Create the fullscreen splash content
	var splashHtml = '<div style="height:100%;"><img alt="" src="icon.png" class="splash_logo_mini" /><br><div class="splashTxtMini" id="splashTxt"><strong>Music Explorer</strong><br><i>'+widgetVersionString+'</i></div></div>';
	var splashDiv = document.getElementById('splashScreen');
	splashDiv.innerHTML = splashHtml;
	splashDiv.className = 'splash_table';
}

function logMsg(logTxt) {
	var splashText = document.getElementById('splashTxt');
	splashTxt.innerHTML = logTxt;
}

// Animator class start
function MultipleImagesAnimator(imageElement, imagePaths, frameInterval)
{
	this.imageElement = imageElement;
	this.imagePaths = imagePaths; 
	this.frameInterval = frameInterval;
	this.currentFrameIndex = 0; 
	this.interval = null;
}

MultipleImagesAnimator.prototype.start = function()
{
	if(this.interval == null)
	{
		var self = this;
		this.interval = setInterval(
			function()
			{
				self.nextFrame();
			},
			this.frameInterval
		);
	}
}
 
MultipleImagesAnimator.prototype.stop = function()
{
	if(this.interval != null)
	{
		clearInterval(this.interval);
		this.interval = null;
	}
}

MultipleImagesAnimator.prototype.nextFrame = function()
{
	this.imageElement.src = this.imagePaths[this.currentFrameIndex];
	this.currentFrameIndex = (this.currentFrameIndex + 1) % this.imagePaths.length;
}
// Animator class end

/*
   **********************************
   Implementation of isSet() function
   **********************************
*/
function isSet(variable) {
	return( typeof( variable ) != 'undefined' );
}